#ifndef WBUI_INCLUDED
#define WBUI_INCLUDED

#include "ctrls2.h"
#include "utils2.h"
#include "html.h"
#include "grid.h"

//#define POINTTOPIXEL 1.3333333 //96/72
struct sUndo;
struct Wformat;
class WBUI:public ctrl {
private:
 bool private4();  //returns true if it update's the cell's contents
 bool private3(bool f2=false,bool check=false);  //returns true if successfully enters mode 2
 void private1(bool changed); //reentering mode 0
 void private2(char cc=0); //reentering mode 0, with formula
 void WBUI::_setfocus(token * tk,long pos=-1);
 void WBUI::_setfocus(long sid);
 bool WBUI::listBeforeDelete();
 bool WBUI::listBeforeMove();
public:
 //bool cutcopymode;
 TBox addr;
 bool WBUI::setcellformula(long sid,long row,long col,SD & text);
 bool WBUI::_settoken(token * tk,bool after,bool msg=true,bool setredarea=false);
 void WBUI::showrr();
 void WBUI::showvz();
 static bool WBUI::intersects(sRange & r1,sRange & r2);
 void WBUI::formatapply(Wformat & fr,sRange & rg);
 void WBUI::formatapplysub(Wformat & fr,sFont & f);
 void WBUI::dcopy();
 void WBUI::CtrlW(bool shift);
 void WBUI::addundo(sUndo & u,sWorkbook * w=0);
 static LRESULT CALLBACK WBUI::formatErecvProc(Wformat * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 SArray<Fallback> savedfallbacks; //savestate
 void WBUI::execundo(sUndo & u);
 void WBUI::undo(SArray2<sUndo> & a);
 void WBUI::addredo(sUndo & uu,SArray2<sUndo> & a);
 void format();
 void merge();
 void unmerge();
 void shownames();
 void savestate();
 void reststate();
 SArray<Fallback> state; //savestate..
 int sposdiff(int spos); //determines the width diff between cursheet & spos
 int sgetpos(HDC hdc,int x,int & sx); //determines the sheet no. given the mouse click X
 sRange getselrange(long sid=0);
 TBox * edtbox;
 long edlrow,edlcol,edcurx,edcury,edspos,edepos,edsid,edrow,edcol;char edtype; //applicable only in mode2
 bool edchanged;
 SD edtext;
 void WBUI::_adjust(TBox &t);
 void WBUI::_skiphiddencols();
 void WBUI::_skiphiddenrows();
 void WBUI::_skiphiddensheets();
 DED void setdataentrymode(bool setheight=true);
 char mode; //0=normal mode, 1=entry mode, 2=formula mode
 sWorkbook wb;
 void resetcolwidth(sRange & r);
 void positione(long caretpos=0);
 TBox e; //for edit in cell
 double _oldwidth;
 sRange _oldselrange;
 int _oldx,_oldcurx,_oldrowh; //,_oldcol;
 char _rclicktype; //can be 'r' or 'c' for row or column right click menu
 static Grid grid,grid2,grid3;
 static TempTable rcmds,rcmds2,rcmds3,rnames;
 static TempTableRst rrnames;
 void WBUI::_setgrid(Grid & grid,TempTable & rcmds);
 bool editincell;
 double xdpi,ydpi;
 void print(bool tell=false); //signed long tellrow=0);
 bool islastsheet();
 void spos2(HDC hdc,int &dx,int &dpos);
 void spos(HDC hdc,int pw);
 int sheight; //,scurx;
 HFONT sfont;
 void setalign(TBox &b,sFont & ft,SD & value);
 void borderlayer(sRange r1,HDC hdc,int t,int l,double zoom,int DPIX,int DPIY);
 int paintsub(int sid,HDC hdc,int dx,int dy,int drow,int dcol,int pw,int ph,double zoom,int DPIX,int DPIY,bool printing,int mt,int ml,int * lastY=0,int er=0,bool draw=true,long *erow=0,long * ecol=0);
 int ppaintsub(int sid,HDC hdc,int dx,int dy,int drow,int dcol,int pw,int ph,double zoom,int DPIX,int DPIY,bool printing,int mt,int ml,int * lastY=0,int er=0,bool draw=true);
 void setfont(TBox & b,sFont & ft,double zoom,int DPIX=ScreenDPIX,int DPIY=ScreenDPIY);
 int getcolwidth(int col,int sid,double zoom,double dpi=ScreenDPIX/72.0);
 void WBUI::editcomment();
 void WBUI::togglerowpagebreak();
 void mrepos();
 void WBUI::_setfocus(sRange & rg);
 void freezepanes();
 void unfreezepanes();
 double getcolwidthsub(int col,int sid);
 bool mrepos2(char dir);
 void WBUI::_setbt(sRange bdrr);
 int getrowheightsub(HDC hdc,int row,int sid,int level,double zoom,int DPIY);
 int getrowheight(HDC hdc,int row,int sid,double zoom,int DPIY=ScreenDPIY);
 int pixelrowdiff3(HDC hdc,long r1,long r2,double zoom,long maxdiff=-1);
 int pixelcoldiff(long c1,long c2,double zoom,long maxdiff=-1);
 void calcmaxh(HDC hdc,int row,int sid,int level,double zoom,int DPIY);
 void moveright();
 void WBUI::reentercfgrid(char c=0);
 void moveleft();
 bool movedown();
 bool moveup();
 void clearselected();
 void selset(sSheet & sh);
 //char WBUI::gettopbdr(long sid,long row,long col);
 //char WBUI::getleftbdr(long sid,long row,long col);
 void repos1(HDC hdc,int top,int bot,int left,int right);
 void repos2(HDC hdc,int &dx,int &dy,int &drow,int &dcol,int top,int left);
 static sRange copyrange;
 static sWorkbook * copybook; //0=no copy
 static bool cutcopymode,clipboardopen;
 static char copytype;//1=range selection, 2=row selection, 3=col selection, 4=full selection, 5=sheets selection. - minus values means cut.
 static Stack<long> copysids;
 void WBUI::insertpaste();
 bool commentdisplayed;
 void paste(char type=0);
 void WBUI::_setsheetdefwh(double w,double h);
 void WBUI::_addurowresize(int r,double oldh);
 void WBUI::_adducolresize(int c,double oldw);
 void WBUI::_setcolw(int c,double w);
 void WBUI::_setrowh(int r,double h);
 void WBUI::_insertrows();
 void WBUI::_insertcols();
 void WBUI::_adducount(sWorkbook * w=0);
 void WBUI::_adducells(sRange r,sWorkbook * w=0);
 void WBUI::_adducell(long sid,long r,long c,sWorkbook * w=0);
 void WBUI::_setfocus(int sid,int r,int c);
 int ucount;
 void WBUI::showcf();
 void WBUI::openclipboard();
 void WBUI::_showgrid(Grid * g,int x,int y);
 void WBUI::_showgrid2(Grid * g,int x,int y);
 void WBUI::selblock();
 Grid * namesgrid, *cfgrid,*listgrid;
 InputBox * rr;
 static LRESULT CALLBACK WBUI::rrErecvProc(WBUI * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 void WBUI::listDblClick();
 void WBUI::rrDblClick();
 void WBUI::ffind(bool rep);
 bool namesBeforeMove();
 bool namesBeforeDelete();
 void namesDblClick();
 int fbarheight;
 void WBUI::_resize(TBox & t);
 bool cfBeforeMove();
 bool cfBeforeDelete();
 void cfDblClick(ctrl * c);
 static LRESULT CALLBACK cfErecvProc(WBUI * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 static LRESULT CALLBACK namesErecvProc(WBUI * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 static LRESULT CALLBACK ErecvProc(WBUI * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 static LRESULT CALLBACK gErecvProc(WBUI * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 void execcmd(Grid * g);
 void zoomout();
 void zoomin();
 bool toexcel();
 bool toxml();
 bool tohtml();
 void WBUI::getselsheets(Stack<long> & sids);
 void WBUI::unsetdataentrymode();
 HFONT hfont,hfontb; //used to display column & row headers
 //int cursheet;
 int topmargin,leftmargin,hheight;
 bool showsheetbar,showcolheader,showrowheader,showformulabar;
 int pixelrowdiff(long sid,long r1,long r2,long maxdiff=-1);
 TBox2 fe; //formula editor
 DED bool Setfocus();
 sWorkbook * pwb,*lastpwb;
 DED void Invalidate();
 void listsheets();
 DED WBUI();
 DED ~WBUI();
 DED void Create(HWND hhwnd);
 DED static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
 static LRESULT CALLBACK listErecvProc(WBUI * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 DED static WBUI * Getref(HWND hwnd);
 DED static SPtrArray ary;
 DED void WBUI::movepgdn();
 DED void WBUI::movepgup();
 DED void WBUI::movehome();
 DED void WBUI::moveend();
 DED void WBUI::moverright();
 DED void WBUI::movelleft();
 DED void WBUI::moveddown();
 sSheet * WBUI::_getcursheet();
 void WBUI::c2moveright();
 void WBUI::c2moveup();
 bool WBUI::_c2end();
 void WBUI::_c2start(sSheet & sh);
 void WBUI::c2moveleft();
 void c2movedown();
 long _colresize,_rowresize,_colclick,_rowclick;
 void WBUI::_mclickpos(int x,int y,int&spos,int&sx,int&r,int&c,int&xx,int&yy,int &w,int &h);
 DED void WBUI::gotovalid();
 DED void WBUI::moveuup();
 void WBUI::repos0();
 DED bool WBUI::isvalid(sCell * c);
 DED int WBUI::pixelcoldiff2(long c1,long c2,long maxdiff=-1);
 DED bool WBUI::isvalid(long sid,long row,long col);
 DED int WBUI::pixelrowdiff2(long r1,long r2,long maxdiff=-1);
 void WBUI::gotoup();
 bool WBUI::gotodown();
 void WBUI::gotoleft();
 void WBUI::gotoright();
 void WBUI::gotoprev();
 bool WBUI::gotonext();
 void WBUI::movenextsheet();
 void WBUI::moveprevsheet();
 //DED void getfields(SDA &fields,SDA & values);
 bool WBUI::ispwd(sCell * c);
 TBox b;
 PDlg pdlg;
};

class WBForm : public Form {
public:
 WBUI wbui;
 WBForm();
};
#include "rt.h"


#endif

