#ifndef SFILE11_INCLUDED
#define SFILE11_INCLUDED
#include "utils2.h"
#include "rawfile.h"
#define FBUFSIZE (64*1024) //53248)
extern unsigned long MAXFBUFS;
//extern unsigned long MAXFBUFS; // (100*1024*1024/FBUFSIZE) //100) //10mb*6
//void * valloc(DWORD size);
//void vfree(void * buf);
struct FBUF {
	void * buf; //points to memory area==FBUFSIZE
	_int64 fpos;  //starting position in the file
	//long bytesinbuf;
	DWORD lasttime;
	bool changed,changed2;
 _int64 wc;//writecount used in RDatabase only (cache3) .....
 DED FBUF(long fbufsize) {
		buf=NULL;
		lasttime=0;
		fpos=0;
		buf=vvalloc(fbufsize); //::VirtualAlloc(0,fbufsize,MEM_COMMIT,PAGE_READWRITE); //|PAGE_NOCACHE);
		//buf=malloc(fbufsize);
		if (buf==NULL) {
			MMsgbox("Error: FBUF() insufficient memory");
		}
		//bytesinbuf=0;
		changed=false;
  changed2=false; //used in RDatabase only (cache) .....
	}
	DED ~FBUF() {
		if (buf!=NULL) {
			vfree(buf); //VERIFY(VirtualFree(buf,0,MEM_RELEASE));
			//free(buf);
		}
	}
};

struct WRITELOG {
	_int64 pos;
	_int64 size;
public:
	inline _int64 getend() {
  return pos+size-1;
 }
 inline void setend(_int64 end) {
  ASSERT(end>=pos);
  size=end-pos+1;
 }
};
#define MAXWLOGSIZE (6000)

typedef bool (CALLBACK * ERRORCB) (void * readcbval);
typedef bool (CALLBACK * READCB) (void * readcbval,void * buf,_int64 pos,long size,_int64 & fbufwc);
typedef bool (CALLBACK * FLUSHCB) (void * flushcbval);
typedef bool (CALLBACK * REMOVECB) (void * readcbval,FBUF * fbuf);

class SFile3 {
private:
 inline void SFile3::updatefwc(_int64 pos,long len);
	DED static FBUF * deleteoldest();
 DED static unsigned long lasttime;
 DED FBUF * deleteoldest2();
	long lastpos; //used in finfblock
	_int64 curpos2;
	DED _int64 getboundrypos(_int64 curpos2);
public:
 RawFile * fwc;
 DED void insert(FBUF * fbuf2);
 DED bool notin(_int64 pos,long size);
 void SFile3::zap();
 long maxfbufs,fbufsize; //must be set before the file is opened/created
 DED static unsigned long hits;
 SD fn;
 static void setmaxram(unsigned long mbs);
 static unsigned long getmaxram2();
 static unsigned long getmaxfbufs2();
 DED bool shouldsavecache(const char * fn);
 DED void savecache(const char * fn,SD & errorstr);
 //DED void loadcache(const char * fn);
 REMOVECB removecb;
 READCB readcb;
 ERRORCB errorcb;
 FLUSHCB flushcb;
 void * readcbval;
 void * flushcbval;
 long getfbufsize();
 DED _int64 getsize2();
 RawFile f;
 DED long getmaxfbufs();
	DED void setmaxfbufs(long);
	DED void setfbufsize(long);
	bool async,nobuffering,writethrough;
	DED unsigned long bytesread();
	DED void flush(bool full=true);
 DED void fputs(const char * buf);
 DED void flush2(bool full=true);
 DED void flush3();
 bool readsub(void * buf,long count);
 bool readsub2(void * buf,long count);
 bool reread;
 DED static bool justchanged;
 bool justchangedsub;
 DED void logwrite(unsigned long count);
 bool logwrites;
 SArray<WRITELOG> writelog;
	//signed long wlogsize;
 bool opened;
 DED static unsigned long totfbufs;
 DED void operator =(SFile3 & sf);
	DED bool Create(const char * fn);
	DED void clearfbufs();
	char readmethod;
	DED static SPtrArray ary;
	_int64 filesize;
	SArray<FBUF *> fbufs;
	DED long findblock(_int64 fpos);
	DED bool eof();
 DED bool open(RawFile * rf);
 DED bool Open(const char * fn);
	DED void movetofirst();
	DED void movetoeof();
	DED void move(_int64 n);
 DED void moveto(_int64 n);
 _int64 writecount;
 DED _int64 getpos();
 DED void close();
 DED bool qread(const void ** buf,long count);
 DED bool qread2(const void ** buf,long count);
 DED bool read(void * buf,long count);
	DED bool read2(void * buf,long count);
	DED void write(const void * buf,long count);
	DED void write2(const void * buf,long count);
 DED ~SFile3();
	DED SFile3();
};
#endif
