#ifndef BSORT_INCLUDED
#define BSORT_INCLUDED

typedef signed char (CALLBACK * BSORTCB) (char * rec,char * ia,void * a,void * b,void * c);
//void tthrow(const char *s);

//#define IBLOCKSIZE5 (500) //(1000) //1000000) //used in addindex
struct IBlock5 {
	int n,top,bot;
	char * buf;
	DED IBlock5(int size) {
  //buf=(char *)halloc(size);
		buf=(char *)vvalloc(size);
  if (buf==0) tthrow("Valloc failed. IBlock5");
		n=0;
	}
	DED ~IBlock5() {
  vfree(buf);
	}
};

class BSort5 {
private:
	DED void insert2(IBlock5 *ib,int top,int blockpos);
	DED void insert(IBlock5 * ib,int top,char * rec);
 char *rec2;
	signed int curibpos,curn;
	//long ibsize;
	//DED bool seek2(const char * d);
 
public:
 int nor,bufsize;
 void BSort5::clearbufs();
 void freetop();
 void freeexcess();
 BSORTCB bsortcb;
	DED void zap();
	IBlock5 * getnewiblock();
	SPtrArray emptyblocks;
	int recsize;
	void *cba,*cbb,*cbc; //call back parameters
	//void zap();
 DED void delset(_int64 &a,bool & rid);
	//DED void setbm(_int64 a);
	//DED _int64 getbm();
 DED _int64 getbm2();
 DED void BSort5::setbm2(_int64 a);
 DED _int64 BSort5::getbm2fast();
 DED void BSort5::setbm2fast(_int64 a);
	DED bool seek(short dd); //const char * d);
	DED char * getcurrec();
 inline char * getcurrecfast() {
  return ((IBlock5 *)iblocks.GetAt(curibpos))->buf+(curn*recsize);
 }
	DED void append();
	DED void Delete();
	DED long GetAbsolutePosition();
 DED void SetAbsolutePosition(long pos);
	//DED void moveto(long pos);
	DED bool isbof();
	DED bool iseof();
	DED void movelast();
	DED bool moveprev();
 DED void move(int i);
	DED bool movenext();
	DED void movefirst();
	DED void operator =(BSort5& Src );
	char * rec;
	DED BSort5();
	DED ~BSort5();
 SPtrArray iblocks;
	DED int getcount();
	DED void close();
	DED void add(bool distinct);
	DED void insert();
	DED void init(int recsizee,void * callbacka,void * callbackb,void * callbackc,BSORTCB bcb);
};

bool clfile(const char * fn,const char * basepath);
#endif
