#ifndef CTRLS_INCLUDED
#define CTRLS_INCLUDED
#define GET_X_LPARAM(lp)                        ((int)(short)LOWORD(lp))
#define GET_Y_LPARAM(lp)                        ((int)(short)HIWORD(lp))
//#error "eee"
#include "utils2.h"
#include "rt.h"
//#include <afxwin.h>
//#include <afxdisp.h>
//#include <commdlg.h>
//#include "baserst.h"
//#include "rdao.h"
#define MAXROWS 30
#define P_INIT1 0
#define P_SETTITLE P_INIT1
#define P_TRUE 1
#define P_FALSE 2
#define P_DISPREC 3
#define P_DISPPAGETITLE 4
#define P_DISPFOOTER 5
#define P_BEFOREENDPAGE 6
#define P_INIT2 7
#define P_INIT0 8
#define P_DISPREC2 9

//#define P_DISPAGEFOOTER
#define EATUP 0 //eats up the message
#define BLUE_COLOR 16777152  //0xHFFFFC0 //RGB(150,150,255)
#define BLACK_COLOR RGB(0,0,0)
#define WHITE_COLOR RGB(255,255,255)
#define RED_COLOR RGB(255,0,0)
#define YELLOW_COLOR RGB(255, 255, 0)
#define PINK_COLOR 14474495 //RGB(255,255,0)
#define GRAY_COLOR RGB(150,150,150)
#define LTGRAY_COLOR RGB(230,230,230)
#define FRAMEBACKGROUND RGB(125,125,125)
#define FRAMEBACKGROUND2 RGB(138,138,138) //used by TBox popup grid. Must be slightly different from FRAMEBACKGROUND, especially if there are no records in the grid
#define GREEN_COLOR RGB(0,255,0)
#define BROWN_COLOR RGB(150,50,80)
#define BUTTON_COLOR RGB(200,200,200)
#define sb_KEYDOWN WM_USER+0
#define sb_DELETE WM_USER+1
#define sb_UNDO WM_USER+2
#define sb_AFTERUPDATE WM_USER+3
#define sb_SOCKET WM_USER+4
#define sb_SYSTRAY WM_USER+5
#define sb_MISC WM_USER+6
#define sb_HIDECOL WM_USER+7
#define sb_SETFOCUS WM_USER+8
#define sb_FILL WM_USER+9
#define sb_STATE WM_USER+10
#define sb_BEFOREMOVE WM_USER+11
#define sb_AFTERDELETE WM_USER+12
#define sb_CREATE WM_USER+13
#define sb_RECALC WM_USER+14
#define sb_RETOTAL WM_USER+15
#define sb_TASKBAR WM_USER+16
#define sb_BEFOREDELETE WM_USER+17
#define sb_AFTERCHANGE WM_USER+18
#define sb_CLICK WM_USER+19
#define sb_AFTERMOVE WM_USER+20
#define sb_TAKEFOCUS WM_USER+21
#define sb_SETRST WM_USER+22
#define sb_AFTEROPEN WM_USER+23 //used in Grid setrst
#define sb_DBLCLICK WM_USER+24
#define sb_DEBUG WM_USER+25
#define sb_CMDLINE WM_USER+26

#define LBL_WHITESTYLE 1
#define LBL_BLUESTYLE 2
#define SITE 'A'

extern char dbg;
void initlib(HINSTANCE hInstance);
void termlib();

#define MENUCLASS2(x,y)  Form * CALLBACK menufunc##y(){return new x;} bool menu##y=Menu2::Register(SD(#x),menufunc##y);
#define MENUCLASS(x)  MENUCLASS2(x,x)

extern HENHMETAFILE hemf;
extern HINSTANCE hInstance;
extern HPEN WhitePen,BluePen,BlackPen,RedPen;
extern HBRUSH GreenBrush,GrayBrush,BlueBrush,WhiteBrush,YellowBrush,PinkBrush,BrownBrush,BlackBrush,RedBrush;
DED extern int LogPixelsY,PixelsPerCM,PixelsPerCMY,ScreenDPIX,ScreenDPIY,ScreenWidth,ScreenHeight;//,ScreenWidthMM; //,ScreenHeightMM;
DED extern int CaptionHeight,BorderWidth,BorderHeight;//,ScrollbarHeight; //,TextHeight,ScrollbarWidth;
void ShowMemoryLeakMsgs();
typedef bool (CALLBACK * ISREADONLY) (WPARAM w);
class ctrl;
typedef LRESULT (CALLBACK * OWNERDRAW) (HDC hdc,int loff,int toff,int width,int height,void * param);
typedef LRESULT (CALLBACK * EVENTPROC) (void * ecb,UINT message,WPARAM wParam,LPARAM lParam,Stack<ctrl *> & st) ;
typedef LRESULT (CALLBACK * DBLCLKPROC) (void * p);
typedef bool (CALLBACK * GRIDCB) (void * p);
class Form;
typedef Form * (CALLBACK * MENUFUNC) ();

class ctrl;
int pointstopixels(double points);
double pixelstopoints(int pixels);
double calcheight(const char * text,const char * fontname,double size,double width);
DED LRESULT callevent(EVENTPROC e,void *eparam,UINT message,WPARAM wParam,LPARAM lParam,ctrl * tb);
DED LRESULT callevent2(EVENTPROC e,void *eparam,UINT message,WPARAM wParam,LPARAM lParam,ctrl * tb,Stack<ctrl*> & st);
//DED ctrl * gettop(Stack<ctrl*> & st);
DED ctrl * getbot(Stack<ctrl*> & st);
DED ctrl * gettop(Stack<ctrl*> & st,int pos=1); //one based
DED void arrange(SArray<ctrl*> & ctrls,int totcols,int padw=0,int padh=0,int loff=0,int toff=0);
DED ctrl * getfocusctrl(SArray<ctrl*> & ctrls);
DED bool Hasfocus(SArray<ctrl*> & ctrls);
DED void Eofset2(SArray<ctrl*>& ctrls,bool eof);
DED void movetop(SArray<ctrl*> & ctrls,int d);
DED extern HWND lastcarethwnd;
class Printing;
typedef LRESULT (CALLBACK * PRINTPROC) (char code, Printing * pp,void * tb);
// HINSTANCE hInstance;
// HBRUSH BlueBrush,WhiteBrush;



//void MMsgbox(const char * s);
//void MMsgbox(char * s);
class Strip;
class ctrl;
class DTR;
class Grid;
class _Worksheet;
//int toexcel(const char * title1,DTR * dtr,const char * rptcode=0,int emptyrows=0,_Worksheet * pws=0,bool wrap=true);
int toexcel2(const char * title1,Grid* grid,const char * rptcode=0,int emptyrows=0,_Worksheet * pws=0,bool wrap=true);
int toexcel(baserst * rst,SD title1);

struct TwoPointers {
	Strip * s;
	ctrl * c;
};
bool Setdownfocus(SArray<ctrl*> &ctrls,ctrl * cc);
bool Setupfocus(SArray<ctrl*> &ctrls,ctrl * cc);
bool Setleftfocus(SArray<ctrl*> & ctrls,ctrl * cc);
bool Setrightfocus(SArray<ctrl*> & ctrls,ctrl * cc);
DED bool focusposition(SArray<ctrl*> & ctrls);
struct Group {
	SD heading;
	char start;
	char end;
	char height;
	Group() {
		height=1;
	}
};


class Label;
extern HDC ghdc;
class ctrl {		//base class for all controls
 friend class Grid;
 friend class Recordset;
 friend bool _gridedit(Grid * grid,TBox * gridctrl,SD & repsrc);
public:
 DED static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
 DED static SPtrArray fonts;
 DED static SDWordArray hfonts,hbrushs,colors,pens,pensizes,penstyles,pcolors;
 DED static HFONT getfont(FONT & f);
 DED static HBRUSH getbrush(COLORREF f);
 DED static HPEN getpen(COLORREF f,int size=0,int style=PS_SOLID);
 DED static HDC gethdcmem(int w,int h);
 DED static bool registered;
 DED static WNDCLASS wc;
 DED static void RegisterClass();
 DED static void Unregisterclass();
 void ctrl::createwindow(HWND pphwnd,bool popup,bool visible);
 int oldwidth,oldheight;
 int rowspan,colspan;
 bool autostreach,_arrange;
 DED static Stack<ctrl*> stack;
	bool locked;
 //DED virtual void Setheight(char n);
 //DED virtual void Setwidth(char n);
 DED virtual bool IsHidden();
 DED bool IsHidden2();
 DED virtual void Show();
 DED virtual void Show2();
 DED virtual void Hide();
	unsigned char printheight;
	Label * lbl;
	DED ctrl();
	DED virtual int Tside();
	bool excel_needed;
	bool infocus;
	unsigned char height;
	char type;
	int oldleft;
	bool softprint;
 DED virtual ~ctrl();
	DED virtual void Setheight(int n);
	//DED virtual void Setwidthint(int n);
	//DED virtual void SetFontdirect(HFONT hf);
	DED virtual bool ischanged();
 DED virtual void SetLock(bool l);
	DED virtual void SetText(const char * s);
	DED virtual StringData GetText();
 DED virtual StringData GetText2();
	DED virtual void Undo();
	DED virtual void Create(HWND hhwnd) {
  MMsgbox("not implemented");
 };
	DED virtual void Setwidth(int n);
 DED virtual void Setleft(int n);
 DED virtual void Settop(int n);
 //DED virtual void Setheightint(int n);
	DED virtual bool Setfocus();
	DED virtual bool Hasfocus();
	DED virtual void SetTextDirect(const char * s);
	//DED virtual void SetTextdirect(const char * s);
	DED virtual int Getheight();
	DED virtual int Getwidth();
	DED virtual int Rside();
 DED virtual int Bside();
	DED virtual void Savestate();
	DED virtual void Reststate();
	SD mask;
 bool neumericfont;
 HWND hwnd,chwnd,phwnd;
	bool astext; // dtr will create a textbox instead of a label
	SD fieldname;
	SD heading;
	bool vertical;  //vertical heading;
	DED virtual int Lside();
	bool tabstop;
	bool changed,justchanged;
	bool somethingchanged;
	bool subtot; //for printing purposes only
 void * eparam;
	DED virtual void Seteventproc(EVENTPROC e,void *param);
	HBRUSH backbrush;
	//COLORREF forecolor;
	//DED virtual void Setbackbrush(HBRUSH bb);
protected:
	EVENTPROC eventproc;
};
//--------------------------Frame ---------------------
class Lbl;
class Frame: public ctrl {
public:
 HWND lasthwnd;
 DED void SetText(const char * s);
 bool delmsg,popup;
 char postquitmsg; //0=never,1=always,2=only if parent is 0
 char savefocus;
 //SD body;
 Lbl * lbody;
 DED void SetBody(const char * s);
 DED static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
 DED static LRESULT CALLBACK ErecvProc(Frame * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
	DED static signed int Getpos(HWND hwnd);
	DED static Frame * Getref(HWND hwnd);
 DED static SPtrArray ary;

 DED void Create(HWND hhwnd);
 COLORREF background;
 DED ~Frame();
 bool border;
 DED Frame();
};
class Grid;
class Gridcolgroup;
class Gridcol;
//--------------------------TBox ---------------------
struct Fhelp {
 SD name;
 SDA params;
 Fhelp(const char * name,const char * params) {
  Fhelp::name=name;
  split(SD(params),Fhelp::params,',');
 }
 void operator =(Fhelp& fh ) {
  name=fh.name;
  params=fh.params;
 }
};
struct RTB {
 int start,end;
 long fore,back;
 long diff;
 HFONT hfont;
 //bool caret;
 //HCURSOR hcursor;
 SD sd;
 SArray2<RTB> rtbs;
 RTB() {
  //caret=true;
  //hcursor=LoadCursor(0,IDC_IBEAM);
  fore=-1;
  back=-1;
  hfont=0;
 }
 void operator =(RTB& r ) {
  sd=r.sd;
  rtbs=r.rtbs;
  start=r.start;end=r.end;fore=r.fore;back=r.back;hfont=r.hfont;
  //caret=r.caret;
  //hcursor=r.hcursor;
 }
 static void apply(SD & s,SArray2<RTB> & rtbs,long off=0);
 void gettext(SD & s) {
  s=sd;
  apply(s,rtbs);
 }
};
class sWorkbook;
class WBUI;
class TBox: public ctrl {
public:
 TBox * TBox::_getfocus();
 RTB * keyrtb;
 SD TBox::GetText(long spos,long epos);
 static SArray2<Fhelp> fhelps;
 Lbl * ttip;
 //int lastcaretx;
 void TBox::showtip(SD & tip,int X);
 WBUI * wbui;
 HFONT hfont2,hfont3; //for formula bracket & strings
 char formula;
 void onmove(bool mmove=false);
 void onchange();
 void TBox::_skipover();
 int TBox::_findleft(Eval & e,int spos,bool comma);
 int TBox::_findright(Eval & e,int spos,bool comma);
 void TBox::_insert(SD & sd,int pos=-1,bool actual=true);
 void TBox::_delete(long spos,long epos,bool actual=true);
 void TBox::_cover(long &spos,long &epos);
 int TBox::_TextWidth(HDC hdc,long pos,int * i=0);
 int TBox::_TextWidth(HDC hdc,long spos,long epos);
 void TBox::_removertbs();
 void TBox::_removertbs2();
 void TBox::_block(long s1,long s2);
 void TBox::_show2();
 long sid,row,col; //sRange addr; //for ttip
 SD TBox::getselection2();
 void TBox::tessellate();
 SArray2<RTB> rtbs,prevrtbs;
 bool dash;
 struct Patch {
  long t,l,b,r; //absolute window coordinates
  COLORREF background,foreground;
 };
 OWNERDRAW ownerdraw;
 void * ownerdrawparam;
 void TBox::ctrlminus();
 void TBox::ctrlplus();
 void TBox::Hide();
 bool TBox::Hasfocus2();
 bool ignoremm;
 TBox * parent; //tooltip parent
 SD TBox::getselection();
 void TBox::getselection(int &spos,int &epos);
 bool TBox::hasselection();
private:
 static bool _closed; //used in onmove ttip
 static SArray<long> _src,_dest; //used in onmove ttip
 static LRESULT CALLBACK ttipErecvProc(TBox * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 void TBox::_ttip();
 int TBox::_find(long pos);
 COLORREF frcolor,bkcolor;
 bool intersects(long t,long l,long b,long r,Patch & p, RECT & rc);
 SArray<long>ppos; //patch positions, used by pPatBlt
 void TBox::pPatBlt(HDC hdc,int l,int t,int w,int h,DWORD rop);
 void TBox::pTextOut(HDC hdc,int l,int t,const char * s,int len);
public:
 //bool noclip;
 double TBox::lines(int h);
 SArray<Patch> patches;
 DWORD lastclicktime;
 bool hilight,oldhilight,setcapturestarted,tristate,drawborder;
 DED bool delsetection();
 HRGN hrgn;
 DED static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
	DED static signed int Getpos(HWND hwnd);
	DED static TBox * Getref(HWND hwnd);
 DED static SPtrArray ary;
 DED static void Unregisterclass();
 Grid * grid;
 int lastmmx,lastmmy;
 int TBox::getX2(int pos);
 int TBox::getpos(SDWordArray & ends,int n,int w,bool bias=false);
 int TBox::getpos(int X,int Y,bool bias=false);
 int TBox::getX(int pos);
 DED bool TBox::willpaint();
 DED StringData TBox::GetText();
 DED StringData TBox::GetText2();
 DED void TBox::breakwords(SD s,SDWordArray & ends);
 DED void TBox::ResizeWidth(int lines);
 DED void TBox::Select();
 DED void TBox::ResizeLines(int width);
 DED bool TBox::ShowGrid();
 DED void TBox::SetFontName(const char * s);
 DED void TBox::SetButtonState(char c);
 DED void TBox::SetFontSize(int n);
 DED void TBox::setcaret();
 void TBox::breaklines(HDC hdc,SDWordArray & ends,int w);
 int TBox::getpos2(int X,int Y,bool bias);
 DED bool TBox::ismultiline();
 DED void TBox::setgridtext();
 DED void TBox::SetTextDirect(const char * s);
 DED void TBox::newgrid();
 DED static LRESULT CALLBACK TBox::ErecvProc(TBox * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 DED void TBox::addcolgroup(Gridcolgroup & grp);
 DED void TBox::addcol(Gridcol & col);
 DED void TBox::DrawText3(HDC hdc,int loff,int toff,int w,int h);
 DED void TBox::setrst(bbaserst * r);
 DED bool TBox::HideGrid();
 void TBox::Hidecaret(bool b);bool carethidden;
 char halign,valign;
 bool blockkey,buttonenterkey,buttonpressed,keepbuttonstate,showcaret,uppercase;
 bool oldchanged,oldjustchanged,oldsomethingchanged;
 bool password,forcesingleline,allowfocus,redline,oldredline;
 char buttonstate;
 DED void TBox::nofocus();
 DED void TBox::setpos(int w);
 int pad;
 HCURSOR hcursor;
 int TBox::calcwidth(HDC hdc,int lines,bool setheight);
 DED void TBox::paintsub(HDC hdc,int loff,int toff,int w,int h,bool noclip=false); //,int parentw,int parenth);
 void TBox::paintsub2(HDC hdc,int l,int t,int w,int h);
 DED void TBox::reststate();
 DED void TBox::savestate();
 DED void TBox::SetMask(const char * s,bool resize=true);
 DED int TBox::getline(SDWordArray &ends);
 DED int TBox::getcw(SDWordArray & ends,int n);
 DED int TBox::getline(int h,SDWordArray &ends);
 DED void TBox::setpos(SDWordArray & ends,int n,int w);
 DED int TextHeight(HDC hdc);
 DED int TextWidth(HDC hdc,const char * s,int len=-1);
 DED bool TBox::Setfocus();
 DED void TBox::SetFontBold(bool t);
 DED void TBox::DrawText(HDC hdc,int loff,int toff,int w,int h);
 DED void TBox::DrawPlus(HDC hdc,int loff,int toff,int w,int h);
 int pos,loffset,selstart,selend;
 int oldpos,oldloffset,oldselstart,oldselend;
 void TBox::_resizettip();
 bool TBox::_collapsetip(bool formula);
 DED void SetText(const char * s);
 DED void SetText(const char * s,int lines,int width=0); //,bool removertbs=true);
 DED int SetHeightLines(double n); //must be called after creation
 int SetHeightLinessub(double n);
 DED void SetWidthChars(double n); //must be called after creation
 DED void TBox::DrawText2(HDC hdc,int loff,int toff,int w,int h);
 DED void TBox::addcol(const char * fieldname,const char * heading="",double  width=10,const char * mask="");
 DED bool TBox::showdd(int pos,bool change=true);
 DED void TBox::Undo();
 //int TBox::Getheight();
 DED virtual void Setheight(int n);
 DED virtual void Setwidth(int n);
 //bool pre
 long maxgridwidth;
 bool settingfocus;
 char arrow;
 DED void TBox::DrawArrow(HDC hdc,int loff,int toff,int w,int h);
 SD text,oldtext,prevtext,oldprevtext;
 FONT font,nfont;
 HFONT hfont,oldhfont;
 COLORREF hfocusbackground,hfocusforeground;
 COLORREF foreground,background,bordert,borderl,borderr,borderb,focusbackground,focusforeground;
 COLORREF oldforeground,oldbackground,oldbordert,oldborderl,oldborderr,oldborderb;
 char cornertl,cornertr,cornerbl,cornerbr;
 char btt,brt,blt,bbt; //border thickness - default 1
 DED void Create(HWND hhwnd);
 int TBox::calcheight(HDC hdc,int width);
 int TBox::calcheightlines(HDC hdc,double n);
 //void Seteventproc
 //EVENTPROC eventproc;
 DED TBox::~TBox();
 //int borderwidth;
 DED TBox::TBox();
};

//--------------------------Lbl---------------------
class Lbl :public TBox {
public:
 DED Lbl();
 DED void setwhitestyle();
};

//--------------------------Btn---------------------
class Btn :public TBox {
public:
 DED Btn();
};

//--------------------------CBox---------------------
class CBox :public TBox {
public:
 DED CBox();
};

//--------------------------TBox2---------------------
class TBox2 :public TBox { //with label
private:
 int _lines,_width; //used in SetLabel
public:
 DED TBox2();
 DED void TBox2::Create(HWND hhwnd);
 Lbl lbl;
 DED void TBox2::Setlblwidth(int n);
 DED void TBox2::Hide();
 DED void Setheight(int n);
 DED void Setwidth(int n);
 DED void SetLabel(const char *s,int lines=0,int width=0);
 DED void Settop(int i);
 DED void Setleft(int i);
 DED int TBox2::Getwidth();
 DED int TBox2::Getheight();
 DED int TBox2::Lside();
};

//--------------------------CBox2---------------------
class CBox2 :public TBox2 { //with label
public:
 DED CBox2();
};

//--------------------------TBox3---------------------
class TBox3 :public TBox2 { //with label
public:
 DED TBox3();
 DED static LRESULT CALLBACK TBox3::ErecvProc(TBox3 * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 DED void TBox3::Setwidth(int n);
 DED void TBox3::Setheight(int n);
 DED int TBox3::Rside();
 DED void Create(HWND hhwnd);
 DED void TBox3::setl();
 Btn btn;
 DED void Settop(int i);
 DED void Setleft(int i);
 DED int Getwidth();
 DED int Getheight();
};
//--------------------------TBox3---------------------
class TBox4 :public TBox2 { //with label
public:
DED  TBox4();
 DED static LRESULT CALLBACK ErecvProc(TBox4 * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 DED void Setwidth(int n);
 DED void Setheight(int n);
 DED int Rside();
 DED void Create(HWND hhwnd);
 DED void setb();
 Btn b1,b2;
 DED void Settop(int i);
 DED void Setleft(int i);
 DED int Getwidth();
 DED int Getheight();
};

//--------------------------Menu---------------------
class IDatabase;
class Form;
class Menu2 : public Frame {
public:
 static SDA classes;
 static bool Register(SD & classs,MENUFUNC mf);
 static LRESULT CALLBACK formErecvProc(void *,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 void additem(const char * name,const char * group=0,const char * fullname=0,bool disabled=false,bool readonly=false,bool total=false,SD misc="",SD misc2="",SD code="",SD cclass="");
 void additem2(const char * classs,const char * name,const char * group=0,const char * fullname=0,bool disabled=false,bool readonly=false,bool total=false,SD misc="",SD misc2="",SD code="");
 void addinmenu(Form *f);
 void removefrommenu(Form *f);
 static Form * Getform(SD classs,long cx);
 static Form * Getnewform(SD classs,long cx=0);
 //Form * instantiate(SD classs,bool activate=false,bbaserst * r=0);
 Menu2();
 TempTable rt;
 TempTableRst rrt;
 SPtrArray freegrids,usedgrids;
 void ffreegrids(int s=0);
 Grid * getnewgrid();
 bool killfocus;
 void hidefreegrids();
 void freegrid(Grid * g);
 void raiseevent(bbaserst * r);
 void gridclick(int x,ctrl * pp);
 void labelclick(int x);
 void delgrids();
 void showgrid(POINT & p,SD grp);
 bool checkkey(MSG msg);
 //IDatabase * db;
 //SD table,where;
 ~Menu2();
 //Recordset rst,rst2;
 int lastlabel;
 void Create(HWND hhwnd); //,Recordset * r);
 SArray<ctrl*> labels; //for the top row
 //SPtrArray grids; //for the active grids
 static LRESULT CALLBACK ErecvProc(Menu2 * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st); //for receiving events from labels & grid
};
//------------------Form-------------------------
extern Frame* pmain;
//extern HWND mainhwnd;
extern Menu2 * menu2;
extern Recordset * rrights; //user&right
extern SD Currentuser;
class Form:public Frame {
 friend class Menu2;
public:
 SD classs;
 DED static unsigned long gcc;
 unsigned long cx;
 static EVENTPROC eventproc2;
 DED static Form* Form::Find(const type_info & t,unsigned long cxx);
 //DED static Form* Form::Find(const type_info & t);
 DED static Form * Form::Find(const char * s,unsigned long cxx=0);
 DED static Form * Form::getactiveform();
 DED static signed int getactivepos();
 bool readonly;
 DED virtual void SetLock(bool l);
 DED Form();
 HWND lasthwnd;
 DED void deactivate();
 Lbl title;
 SArray<ctrl*> ctrls;
 //static char getright(SD s);
 DED void activate();
 DED static LRESULT CALLBACK ErecvProc(Form * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 DED static SArray<Form*> ary;
 DED virtual ~Form();
};

class Form2:public Form {
public:
 Form2() {
  allowdelete=true;
 }
 bool allowdelete;
 DED virtual void Goto(const char * id);
 DED virtual void Fill();
 Recordset rst;
 DED static LRESULT CALLBACK ErecvProc(Form2 * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 virtual bool Beforemove(bool forced)=0;
 DED virtual void movenext();
 DED virtual void moveprev();
 DED virtual void movelast();
 DED virtual void movefirst();
 DED virtual void Delete();
 DED ctrl * Form2::gettopctrl();
 DED bool somethingchanged(bool forced);
};
//extern Form*activeform;
//--------------------------TextBox ---------------------
class Label;


/*//------------Printing Starts--------------------------------
class Grid;
//---------------Printing Ends-----------------
//-----------------Repeater starts --------------------------
class Repeater: public ctrl {
public:
	//SD rptcode;
	CUIntArray selary;
	char headlines;
	Strip * strip;
	virtual bool selected()=0;
	bool allowdelete,allowaddition;
	Printing pp;
	SPtrArray labels,groups,glabels;
	virtual void RefreshAll(bool updt=false)=0;
	virtual void Addgroup(Group * g)=0;
};*/

//-----------------DTR starts --------------------------
//class DTR;


//#include "grid.h"
//---------------MDI Form starts-------------
/*class STDForm;
class MDIForm:public ctrl {
 private:

	static bool registered;
	static WNDCLASS wc;
	static SD classname;
 static void RegisterClass();
 static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
 static int Getpos(HWND hwnd);
 protected:
 static LRESULT CALLBACK ErecvProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam, void * tb);

 public:
 static void Unregisterclass();
 static SPtrArray ary;
	bool readonly;
	virtual void makereadonly();
	STDForm * form;
	void * mmisc;
	Label title;
	static MDIForm * Getref(HWND hwnd);
	static MDIForm * callerform;
	virtual void Fill();
	//Recordset rst;
	DTR dtr;
	//Grid grid;
	virtual bool Setfocus();
	virtual void Delete();
	virtual bool Beforemove(bool force);
	virtual void moveprev();
 virtual void movenext();
	virtual void movefirst();
	virtual void movelast();

 virtual bool iseof();
 SPtrArray ctrls;
	virtual void beforeclose();
 HWND lasthwnd; //for setting focus on activation
	EVENTPROC eventproc;
	static HWND clienthwnd;
 MDIForm();
	virtual ~MDIForm();
 void Create(const char * title);
 HWND hwnd;

 private:
	WNDPROC oldproc;
};
//-----------------MDI form ends--------------
//-----------------MDI APP Class starts------------
class MDIApp:public ctrl {
private:
	WNDPROC oldproc;
public:
 static void Unregisterclass();
	static LRESULT CALLBACK subproc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
	MDIApp(const char * title,HMENU mainmenu,HMENU windowed);
	~MDIApp();
 static EVENTPROC eventproc;
	static SPtrArray Forms;
	static bool registered;
	static WNDCLASS wc;
	static SD classname;
 static void RegisterClass();
	static bool automaximize;
 static HWND hwnd,clienthwnd;
	static LRESULT CALLBACK FrameProc(HWND ,UINT, WPARAM ,LPARAM);
	void AddForm(MDIForm * f);
};*/

//--------------Per---------------------------
class Per :public Frame{
private:
 int w,h;
 bool active;
 bool fore;
 //SD sd;
public:
 DED void Inc();
 long count,tcount;
 bool donothide;
 void Per::Hide(bool final=false);
 SD subtext;
 DED void Show(const char * text,long tcount);
 //DED void Hide();
 DED void SetPercentage(double per); //between 0 & 1
 static LRESULT CALLBACK Per::ErecvProc(Per* tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> &st);
 double per;
 Lbl tbox;
	DED Per();
	DED ~Per();
};
//-----------Per Ends -------------------------

//--------------Find---------------------------
class Find :public Frame{
private:
	//DED static Find * tb;
	bool search; //must be passed through activate
public:
	SArray<ctrl*> ctrls;
	char lastbutton;
	DED static LRESULT CALLBACK ErecvProc(Find * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
	Btn bfind,bfindprev,bfindnext;
	TBox2 tbox,rep;
 CBox2 ccase,formula,repformula;
 Btn brep,brepprev,brepnext,brepall;
	DED bool activate(bool search=true,bool showrep=false);
 Grid * grid;
 TBox * gridctrl; //applicable only if grid is set....
	bool status;
	bbaserst * rst;
	const char * fieldname;
	DED Find();
	DED ~Find();
};
DED extern Find * find;
//-----------Find Ends -------------------------
//-----------Image Box Starts----------------------------
class ImageBox: public ctrl {
 private:

	WNDPROC oldproc;
	static LRESULT CALLBACK subproc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
	SDA badpaths;
	static SPtrArray ary;
	static bool registered;
	static WNDCLASS wc;
	//static SD classname;
 static void RegisterClass();
 //static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
	//static LRESULT CALLBACK subproc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);

	//static void SetSelstart(HWND hwnd,int pos);
	bool locked;
	bool justchanged;
	struct state {
		SD text,prevtext;
		SD mask;
		int selstart;
  bool justchanged,changed,somethingchanged;
	} st;
	struct image {
		SD fn;
		HBITMAP hbmp;
	};
	SPtrArray images;
 //HBITMAP getbmp(const char * ss);
 FONT font;
 public:
	void FontSize(char size);
	void FontBold(bool bold);
	void AddLabel(const char * s);
	void setlblwidth(int w);
	void dispimg(HDC hdc,int x, int y,int width,int height,bool patblt);
	void removebmp(const char * ss);
	//HWND chwnd;
 void Setbackbrush(HBRUSH bb);
 //void SetTextdirect(SD s/*const char * s*/);
	void SetLabel(const char * s);
 ImageBox(HWND hhwnd);
	ImageBox();
	~ImageBox();
	void Setwidthint(int n);
	void Savestate();
 void Reststate();
	int Textlen();

 bool Hasfocus();
	bool Setfocus();
	//int charwidth;
 void Create(HWND hhwnd);
	void Visible(bool v);
	void tlbh(int t,int l,int b,int h);
	void SetLock(bool l);
 bool GetLock();
	//void SetText(const char * s);
	//void GetText(SD * s);
	StringData GetText();
	void Undo();
	void Setmask(const char * s);
	static void Maskset(const SD * mask,SD * s);
	COLORREF foreground;
	SD prevtext;
 //bool changed;
 HWND /*hwnd,*/phwnd;
 //EVENTPROC eventproc;
	//void Seteventproc(EVENTPROC e);
 //void Setwidth(char n);
 void Setleft(int n);
 void Settop(int n);
 int Getheight();
	int Getwidth();
 int Rside();
 int Bside();
 void Setheightint(int n);
 void SetSelstart(int pos);
 static unsigned int Getpos(HWND hwnd);
 HBITMAP bmp;
 private:
	//static unsigned int Getpos(HWND hwnd);
	static ImageBox * Getref(HWND hwnd);
	//HWND hwnd,chwnd,phwnd;
	//SD mask;
	bool focus;
	//WNDPROC oldproc;
	bool ignorechange;
	SD filename;
};
//extern MDIApp * mdiapp;

//---------------STD Form starts-------------

/*class STDForm:public ctrl {
public:
	//char askforclose;
	static void Unregisterclass();

 protected:
 // LRESULT CALLBACK ErecvProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam, void * tb);

 public:
	bool paintexternal,fullscreen,scrollbars;
	bool _3d,flatmode;
	 LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
 bool postquitmsg;
  STDForm * Getref(HWND hwnd);
	void * misc;  //empty buffer pointer - may be used by parent class
	HBRUSH backbrush;
	EVENTPROC eventproc;
	 HWND clienthwnd;
 STDForm();
	virtual ~STDForm();
 void Create(const char * title);
 HWND hwnd;

 private:
	WNDPROC oldproc;
};
//-----------------STD form ends--------------*/
//class DaoRecordset;
//-----------Login class starts ---------------
class LLogin :public Frame {
private:
	DED static LRESULT CALLBACK ErecvProc(LLogin * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> &st);
 //Frame form;
public:
	TBox2 name,pwd,company;
	DED LLogin(bool askcompany=false);
	DED virtual ~LLogin();
	SArray<ctrl*> ctrls;
	SD lastname,lastpwd,lastcompany;
	DED void setrst(baserst * r);
	DED void ask(void * f=0);
};

//-----------InputBox class starts ---------------
class InputBox : public Frame{
public:
	static LRESULT CALLBACK ErecvProc(InputBox * tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 bool ok;
	TBox2 txt;
	InputBox(const char * label,bool ddown=false);
	virtual ~InputBox();
	//SD lastname;
	void setrst(baserst * r);
	void ask();
};
DED SD inputbox(const char * label,const char *txt=0,baserst * rst=0,const char*listfield=0,bool lcase=false,bool pwd=false);
DED bool inputbox2(const char * label,SD & txt,bool lcase=false);

//-----------Merge class starts ---------------
class Merge{
private:
	DED static LRESULT CALLBACK ErecvProc(Merge * ttb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 Frame form;
	//Lbl lold,lnew;
public:
	SD keyfield,descfield;
	SArray<ctrl*> ctrls;
	TBox2 old,nnew;
	Btn b;
	Lbl desc1,desc2;
	//TextBox pwd;
	DED Merge();
	DED virtual ~Merge();
	SD oldname,newname;
	DED void setrst(baserst * r);
	DED void ask();
 DED static Merge * tb;
};

//-----------Change password class starts ---------------
class ChangePwd{
private:
	static LRESULT CALLBACK ErecvProc(ChangePwd * ttb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 Frame form;
	//Lbl lold,lnew;
public:
	TBox2 old,nnew;
	ChangePwd();
	virtual ~ChangePwd();
	SD oldpwd,newpwd;
 SArray<ctrl*> ctrls;
	//void setrst(SDaoRecordset * r);
	void ask();
 static ChangePwd * tb;
};

class CallbackWindow {
//private:
	//static bool registered;
public :
	WNDPROC wndproc;
	HWND Create();
	HWND hwnd;
	//static SD classname;
	~CallbackWindow();
	CallbackWindow();
};


/*//-----------------VDTR starts --------------------------
//class VDTR;
class VDTR: public Repeater {
public:

	void Undo();
	void Savestate();
	void Reststate();
	struct {
		int curtop;
		int absposition;
	} saves;
	bool selected();
	void deselect();
	void select();
	void clearselection();
	CUIntArray selary;
 bool Hasfocus(void);
	bool printexternal;
	bool refreshonpaint;
	void RefreshForward();
	//bool allowdelete;
 VDTR(HWND hwnd);
	VDTR();
	~VDTR();
//	void Create(HWND hwnd);

	int striptop;
	void Visible(bool v);
	void SetBackground(COLORREF col);
	void Create(HWND hwnd);
	HWND phwnd,hwnd2;
 //EVENTPROC eventproc;
 static LRESULT CALLBACK ErecvProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam, Stack &st);
 //void SetBackground(COLORREF col);
 void Setstrip(Strip * s);
	void Setheight(double n); //no. of strips
	void Setheightint(int n);
	void Setrst(baserst *r);
	bool Setfocus();
	SHORT Movedown();
	void Capturecurrent();
	void Setstriptop();
	void Prevset();
	void Paint(int n);
	long dtrh,dtrw;
	//char headlines;
	LONG lasttime;
	//baserst *rst;
	SHORT Moveup();
	SHORT Movetop();
	SHORT Movebottom();
	SHORT Movepagedown();
	SHORT Movepageup();
	//SPtrArray labels;
	//SPtrArray groups;
	//Printing pp;
	void Addgroup(Group * g);
	void RefreshAll(bool updt=false);
	//bool allowaddition;
 //Strip * strip;
 //char currentrow;
 long curtop;
private:
	struct BMP{
  HBITMAP hbmp;
		long top,height,cap_height;
	};
	int curbmppos;
	void insertbmp(VDTR::BMP bmp);
	void clearbmps();
	int totbmps;
	void addbmp(VDTR::BMP bmp);
	 VDTR * Getref(HWND hwnd);
	HBRUSH background;
	//Strip * strip;
	void deletebmp(int x);
 void adjustcurbmp();
	int getavgh();
 BMP bmps[MAXROWS];
	//char totrows,totcompleterows;
	//void settotrows(int h);
	//int stripheight;
};
/*
  strip->height (using VDTR functions)->recordset
  filling to occur when you set the recordset.
  total rows to be determined when you set the height
*/
//-----------------VDTR ends -----------------



/*class TabCtl: public ctrl {
 private:
	HPEN pen;
	static SPtrArray ary;
	static bool registered;
	//static WNDCLASS wc;

 static void RegisterClass();
	//static void SetTextdirect(const char * s,HWND hwnd);
 static LRESULT CALLBACK Proc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);
	static LRESULT CALLBACK subproc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);

	static void SetSelstart(HWND hwnd,int pos);
	void ApplyFont();
	public:
	void Addtab(char *s);
	bool item_no_type,plustype;
 void hideborder(char c);
	void showborder();
	void lcase();
 int Getsellength();
 bool justchanged; //used for after update
 double dvalue();
 long lvalue();
 //TabCtl(HWND hhwnd);
	TabCtl();
	~TabCtl();
	//SD GetText();
	void Setwidthint(int n);
	//void Savestate();
 //void Reststate();
	//int Textlen();

 //bool Hasfocus();
	//void Setfocus();
	int charwidth,charheight;
 void Create(HWND hhwnd);
	void Create(HWND hhwnd,bool multiline,bool rightallign=false,bool password=false);
	void Visible(bool v);
	void tlbh(int t,int l,int b,int h);
	void FontName(char * c);
	void FontSize(char size);
	void FontBold(bool bold);
	void FontUnderline(bool underline);
	void FontStrikeout(bool strikeout);
 void FontItalic(bool italic);
	//void SetLock(bool l);
 //bool GetLock();
	//void Setmaskdirect(const char *s,bool refresh=false);
	//SD GetMask();
	//void SetText(const char * s);
	//void GetText(SD * s);
	//void Undo();
	//void Setmask(const char * s);
	//static void Maskset(const SD * mask,SD * s);
	//COLORREF foreground;
	SD prevtext;
 //bool changed;
 HWND phwnd;
 //EVENTPROC eventproc;
	//void Seteventproc(EVENTPROC e);
 //void Setwidth(char n);
	RECT getdisprect();
 void Setleft(int n);
 void Settop(int n);
 int Getheight();
	int Getwidth();
	RECT getitemrect(int i);
	SD getcurtab();
	void setcurtab(int i);
 int Rside();
 int Bside();
	//void Setheight(char n);
 void Setheightint(int n);
 //void SetSelstart(int pos);
	//void SetTextdirect(const char * s);
	//void SetSellength(int l);

	HFONT GetFont();
	FONT font;
 //static void SetTextdirect(const char * s,HWND hwnd);

 protected:
	static unsigned int Getpos(HWND hwnd);
	static TabCtl * Getref(HWND hwnd);
	private:
	//HWND hwnd,chwnd,phwnd;
	bool focus;
	WNDPROC oldproc;
	HFONT hfont;
	bool ignorechange;
};*/

//--------------DDialog---------------------------
class DDialog:public Frame {
public:
 DED void eenum(long size,int fontsize=11);
 DED void eenum2();
 bool l;
 Btn submit;
 DED DDialog();
 SArray<ctrl*> ctrls;
 DED static LRESULT CALLBACK ErecvProc(DDialog *tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
};

//--------------Dialog Ends---------------------------

/*//--------------Calender---------------------------
class Calender{
private:
	static Calender* tb;
	//bool search; //must be passed through activate
public:
 static void Unregisterclass();

	//SPtrArray ctrls;
	//char lastbutton;
	static LRESULT CALLBACK ErecvProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam, Stack & st);
	HWND hwnd,phwnd;
	static bool registered;
	static WNDCLASS wc;
	static SD classname;
 static void RegisterClass();
	bool isday(void *pp);
	Lbl lmonth,wdays[7],days[7*6],prev,next;
	//SD getmonthtext();
	void fillall(bool resize=false);
	static LRESULT CALLBACK Proc(HWND ,UINT, WPARAM ,LPARAM);
	bool activate(RECT * r);
	//static Button bfind;
	void Create(HWND);
	bool status;
	//baserst * rst;
	//const char * fieldname;
	//SD Gettext();
	void pprev();
	void nnext();
 Calender(HWND);
	Calender();
	~Calender();
};
extern Calender* calender;
//-----------Calender Ends -------------------------*/
DED int navigate(SArray<ctrl*> & ctrls,WPARAM wParam,ctrl * c);
DED bool navigate(MDIForm * form,WPARAM wParam,ctrl * c,baserst  * rst,bool multifind=false);
DED ctrl * Getctrlbyfield(SPtrArray * ctrls,char * fieldname);
DED void SetErecvProcall(SArray<ctrl*> & ctrls,EVENTPROC ep,void * param);
DED ctrl * getfocusctrl(SPtrArray * ctrls);
//void updatefile(const char * fn,ComboBox * cb,const char * val);
//void fillcombo(const char * fn,ComboBox * cb);
DED bool checkqw(ctrl * w,ctrl * q);
//int printctrls(SPtrArray & ctrls,Printing * pp,bool setmargin=true);
class PDlg : public Frame {
public:
 bool landscape; //default value ...
 bool devmodeset;
 SD devmode; //buffer for devmode
 PDlg();
 HDC CreateDC();
 SArray<ctrl*> ctrls;
 TBox3 name;
 TBox2 pagefrom,pageto;
 TBox3 scope;
 TempTable rscope,rnames;
 Btn bok;
 Btn prop;
 bool ok;
 void Show();
 static LRESULT CALLBACK PDlg::ErecvProc(PDlg *tb,UINT message,WPARAM wParam,LPARAM lParam, Stack<ctrl*> & st);
 //TempTableRst r;
};

#endif
