#ifndef RAWFILE
#define RAWFILE

#ifdef EXPP
 #define DED __declspec (dllexport)
#else
 #ifdef IMPP
  #define DED __declspec (dllimport)
 #else
  #define DED
 #endif
#endif


class RawFile {
public:
 void makesparse();
 bool shareread,sharewrite,readonly;
	DED void reset();
	_int64 bytesread,byteswritten,readticks,writeticks;
	unsigned long nreads,nwrites,nmoves;
	bool async,random,seq,writethrough,nobuffering;
 bool writepending;
	SD tempfn;
 void clearpendingread();
 void clearpendingwrite();
	HANDLE h;
 RawFile * tie;
 void * vbuf; //used withb async
 long vbufsize;
 class :public OVERLAPPED {
 public:
  unsigned long size;
 } ov;
 //OVERLAPPED ov;
 _int64 curpos;//used with async
	DED RawFile() {
  tie=0;
  curpos=0;
  memset(&ov,0,sizeof(ov));
  vbuf=0;
  vbufsize=0;
  writepending=false;
  async=false;
  random=false;
  readonly=false;
  shareread=false;
  sharewrite=false;
		h=INVALID_HANDLE_VALUE;
		writethrough=false; //true;
		seq=false; //true;
		nobuffering=false;
	}
 DED void movetoeof();
 DED void move(_int64 n);
	DED _int64 getcurpos();
	DED _int64 getfilesize();
 DED bool setfilename(const char * fn);
	DED bool write(void * buf,long size);
 bool writeasync(void ** buf,long size);
	DED bool read(void * buf,long size);
 DED bool read2(void * buf,long size);
 DED bool lock(DWORD timeout); //in milliseconds
 DED void unlock();
	DED void moveto(_int64 n);
 DED bool isopen();
 DED void moveto2(_int64 n);
	DED bool create();
	DED bool create(const char * fn);
	DED bool open(RawFile * rf);
	DED bool open(const char *c);
 DED void operator =(RawFile & f);
	DED void close();
	DED ~RawFile() {
		close();
  if (vbuf) vfree(vbuf);
	}
};
#endif
