#include "bsort5.h"
//#include "rt.h"

struct IDS;

typedef BSort5 BSORT;
typedef bool (* SQLCB) (Recordset * rst,void * sqlcbval);
class ReportTable;
class Recordset:public baserst {
 private:
 void Recordset::_rlnext();
 void Recordset::_rlprev();
 static signed char CALLBACK bsortcb7(char * rec,char * ia,SD * sds,Recordset *rst,Recordset * rst2);
 void fillrecsd(StringData * sd,long n);
 bool open;
 bool getnext(IndexNode * in, _int64 * inpos,signed long * curpos);
 bool getprev(IndexNode * in, _int64 * inpos,signed long * curpos);
 bool getright(IndexNode * in, _int64 * inpos,signed long * curpos,signed long *top,signed long *bot);
 bool getleft(IndexNode * in, _int64 * inpos,signed long * curpos,signed long *top,signed long *bot);
 signed char cmpia2(StringData * sd2,IDS::indexinfo * inf,unsigned char level,_int64 base);
 void init();
 DED void setjoinsub(Join * j);
 DED void harddelete(unsigned long pos1,unsigned long pos2,signed long TOTFPOS);
 DED void softdelete(unsigned long pos1,unsigned long pos2); //,signed long TOTFPOS);
 DED void clearfda();
 PWhere pw;
 public:
  static bool isok(int pos,int size,Eval * ev);
  static short seekstr(int pos,int size,Eval * ev,bool * islike=0);
  static void reversedir(char * s);
  static void sswap3(int x,int y,SDWordArray &apos,SDWordArray & asize);
  Socket2 * s;
  long _ttpos(); //used by grid double click
  DED Recordset();
  DED Recordset(IDatabase & db);
  DED Recordset(IDatabase * db);
 
  //Recordset(IDatabase * d) {
   
  // db=d;
  //}
 bool seekcore(RST * rst,short dd,StringData * sd,unsigned char level,_int64 llastp);
 DED void softdelete();
 DED void softinsert(Recordset & r);
 SQLCB sqlcb;
 void * sqlcbval;
 DED void getfield2sub(RST * rst,signed long pos,StringData & sd);
 DED void setrst();
 //bool keyinram2;
 //SByteArray odts; //orderby ids
 //SDWordArray onids,omaxsize;
 //long keyscovered;
 BSORT sort;
 struct BS4 {
  int seeklevel;
  SByteArray desc,odts;
  SDWordArray omaxsize,oids;
  SDA osda;
  StringData sd; //used in bsortcb6
  //long keyscovered;
  void clear() {
   desc.RemoveAll();
   odts.RemoveAll();
   omaxsize.RemoveAll();
   oids.RemoveAll();
  }
 } bs4;

 IDS::indexinfo * inf;
 //DED static void closeall(IDatabase * db);
 //DED static void closeall2(IDatabase * db); //called when the IDATABASE is being deleted
 //SDArray rtfields; //used in insert2
 //bool keyinram;
 DED void reopen();

 DED void setr2(Join * j);
 DED void removejoin2(Join * j);
 DED long GetMaxSize(signed long pos);
 IDS * ids;
 //DED StringData Recordset::getfield2(signed long pos);
 DED void Recordset::operator =(IDatabase & db);
 DED void Recordset::operator =(IDatabase * db);
 DED void Recordset::Setdb(IDatabase * db);
 
 DED bool Find(const char * ssql,char dir,SD repsrc=SD(),bool repformula=false,signed long repdestfid=-1,Grid * grid=0,TBox * gridctrl=0);
 //DED void restbookmark(BookMark & bm);
 //DED BookMark getbookmark();
 DED void Recordset::SetAbsolutePosition(long n);
 DED StringData & GetFieldValue3(const char * fn,StringData &sd);
 DED StringData GetFieldValue3(const char * fn);
 DED StringData GetFieldValue3(signed long pos);
 DED StringData & GetFieldValue3(signed long pos,StringData &sd);
 DED StringData GetFieldValue(signed long pos);
 //unsigned char getid(const char *fn);
 DED unsigned char GetFieldType(signed long pos);
 //DED static SArray<Recordset *> ary;
 RST handle;
 //DED bool find(signed long fid,const char * text,char dir,bool casesensitive,bool formula,bool exact=true);
 DED long iskey(signed long pos,long & size,unsigned char &dt);
 DED bool IsOpen();
 DED bool iopen(const char * tablename);
 DED bool iposition();
 DED void setjoin(Join * j);
 //void  Close2();
 DED long GetRecordCount();
 DED long GetFieldCount(Join * upto=0);
 DED long GetFieldCount2();
 DED long GetAbsolutePosition();
 DED short GetEditMode();
 DED void restbookmark(BookMark * bm);
 DED void deletebookmark(BookMark * bm);
 DED BookMark * savebookmark();
 DED void setdeleted(bool b);
 //DED Recordset();
 DED ~Recordset();
 static void tofindformula(SD & s,unsigned char dt,bool casesensitive,SD &fn,bool exact);
 DED void Close();
 DED bool positionto(_int64 lastp);
 DED void fillfda(const unsigned char *fdabuf);
 SPtrArray bookmarks;
 bool reposition;
 //DED bool find(const char * fieldname,const char * text,char dir,bool casesensitive=true,bool formula=false,bool exact=true);
 DED StringData getjname(signed long jpos);
 DED signed long Recordset::getoffset(signed long fpos);
 DED signed long getjpos(signed long fpos);
 DED signed long getfpos(const char *fn);
 DED signed long getfpos2(const char *fn,bool eval=false);
 DED signed long getfpos3(const char *fn);
 inline void Recordset::readdouble(signed long offset,void * buf) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,8));
 }
 inline void Recordset::readlong(signed long offset,void * buf) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,4));
 }
 inline void Recordset::readlonglong(signed long offset,void * buf) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,8));
 }
 inline void Recordset::readfloat(signed long offset,void * buf) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,4));
 }
 inline void Recordset::readword(signed long offset,void * buf) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,2));
 }
 inline void Recordset::readchar(signed long offset,void * buf) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,1));
 }
 inline void Recordset::readfstring(signed long offset,void * buf,long maxsize) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->f.moveto(handle.lastp+sizeof(IDatabase::RecordHeader)+offset);
  VERIFY(db->f.read(buf,maxsize));
 }
 inline void Recordset::readstring(signed long offset,SD & sd) {
  ASSERT(offset>=0 && (unsigned long)offset<ids->recordsize);
  db->fetchstring(&sd,handle.lastp+sizeof(IDatabase::RecordHeader)+offset,0);
 }

 DED StringData & getfield3(signed long pos,StringData & sd);
 //DED StringData & getfield2(signed long pos,StringData & sd);
 DED StringData & GetFieldValue(signed long pos,StringData &sd);
 DED StringData & GetFieldValue(const char * fn,StringData &sd);

 DED StringData GetFieldName(signed long pos);
 DED StringData GetFullFieldName(signed long pos);
 DED SD GetCurrentIndex();
 DED unsigned char GetFieldType(const char * fn);
 DED void SetCurrentIndex(const char * s);
 DED StringData getfieldstr(const char * fn);
 DED SD getfieldstr(signed long pos);
 bool istotal();
 void deletetotal(); //special called from grid only..
 DED void getnullfield(signed long pos,StringData & sd);
 DED bool Open(const char * table,const char *index);
 DED bool Open(const char * sql);
 DED void Resort(const char * orderby);
 //DED bool open2(const char * sql);
 DED void movefirst();
 DED void movelast();
 long movesub(RST * rst,_int64 from,int n);
 DED void movenext();
 DED void moveprev();
 DED void MoveFirst();
 DED void MoveLast();
 DED void MoveNext();
 DED void MovePrev();
 //DED BookMark getsavedbookmark();
 //DED void setsavedbookmark(BookMark& bm);
 DED void edit();
 DED bool IsDeleted();
 //DED void gotobookmark();
 //DED void markbookmark();
 DED bool Seek(const char * d,StringDataArray & sd);
 DED bool Seek(const char * d,StringData *sd,unsigned char n);
 DED bool Seek2(short d,StringData * sd,unsigned char n);
 char lastea;
 DED void AddNew();
 DED void Edit();
 DED void Update();
 DED void oldUpdate();
 DED void Insert2();
 DED void buildposmap();
 //SDWordArray rtlink;
 DED bool haskey();
 DED void CancelUpdate();
 //SDA osda; // order by //SPtrArray ra;
 DED static LRESULT CALLBACK  evalcbv(Eval * e,Recordset *rst,token * t,token * newt);
 DED void fillrec(char * rec);
 DED void move(int n);
 //DED bool openrstz2(Eval * ev,EVALJoin & ej,const char *tablename,const char *indexname,SDWordArray & orderby,SByteArray & desc,bool distinct,SDWordArray & distincts,Recordset * rrst);
 //DED bool openrstz3(Eval * ev,EVALJoin & ej,const char *tablename,const char *indexname,SDWordArray & orderby,SByteArray & desc,bool distinct,SDWordArray & distincts,Recordset * rrst);
 DED bool openrstz4(unsigned long top,unsigned long first,Eval * ev,EVALJoin & ej,const char *tablename,const char *indexname,SDWordArray & orderby,SByteArray & desc,bool distinct,SDWordArray & distincts,Recordset * rrst);
 DED StringData GetFieldValue(const char * fn);
 DED void SetFieldValue(signed long pos,const StringData & sd);
 DED void SetFieldValue(const char * fn,const StringData &sd);
 DED void append();
 DED void Delete();
 DED inline bool IsEOF() { return iseof();}
 DED bool iseof();
 DED bool isbof();
 DED inline bool IsBOF() {return isbof();}
 DED void requery2(SD & sd);
 DED void requery(const char * fn=0,const char * txt=0);
 DED static bool chkfieldtype(unsigned char dt,StringData &sd);
 //void updatejoins(bool & afterparentupdate);
 //DED void setfield2(signed long pos,StringData &sd);
 DED void newrt();
};
//void copyrec1(baserst & src,baserst & dest);
